#include <windows.h>
#include <share.h>
#include "murdsiwr.h"

MultiReaderSingleWriter g_sync;
HANDLE g_hStop;

CRITICAL_SECTION g_csLog;
CString g_log;

struct LogInit
{
    LogInit() { InitializeCriticalSection(&g_csLog); }
    ~LogInit() { DeleteCriticalSection(&g_csLog); }
} logInit;

void PutLog(LPCTSTR entry)
{
    EnterCriticalSection(&g_csLog);
    FILE* f = _tfsopen(g_log, TEXT("at+"), _SH_DENYWR);
    if (f)
        _ftprintf(f, TEXT("%s\n"), entry);
    fclose(f);
    LeaveCriticalSection(&g_csLog);
}

CString ToString(bool res)
{
	return (res ? TEXT("true") : TEXT("false"));
}

DWORD WINAPI ReadThread(LPVOID pVoid)
{
	PutLog(CString(TEXT("+++ ENTER +++ ")) + TEXT(__FUNCTION__));
	DWORD timeout = (DWORD)pVoid;
	do
	{
		BOOL res = g_sync.EnterRead();
		PutLog(TEXT("Doing read..."));
		if (WAIT_OBJECT_0 == WaitForSingleObject(g_hStop, timeout))
			break;

		PutLog(TEXT("Ended read."));
		res = g_sync.LeaveRead();
	}
	while (1);

	PutLog(CString(TEXT("--- RETURN --- ")) + TEXT(__FUNCTION__));
	return 0;
}

DWORD WINAPI WriteThread(LPVOID pVoid)
{
	PutLog(CString(TEXT("+++ ENTER +++ ")) + TEXT(__FUNCTION__));
	DWORD timeout = (DWORD)pVoid;
	do
	{
		BOOL res = g_sync.EnterWrite();
		PutLog(TEXT("Doing write..."));
		if (WAIT_OBJECT_0 == WaitForSingleObject(g_hStop, timeout))
			break;

		PutLog(TEXT("Ended write."));
		res = g_sync.LeaveWrite();
	}
	while (1);

	PutLog(CString(TEXT("--- RETURN --- ")) + TEXT(__FUNCTION__));
	return 0;
}


int main()
{
    TCHAR path[MAX_PATH] = {0};
    if (GetModuleFileName(NULL, path, MAX_PATH))
    {
        g_log = path;
        g_log += TEXT(".log");
    }

	g_hStop = CreateEvent(NULL, TRUE, FALSE, NULL);

	DWORD threadId;
	CloseHandle(CreateThread(NULL, 0, WriteThread, (LPVOID)2000, 0, &threadId));
	CloseHandle(CreateThread(NULL, 0, ReadThread, (LPVOID)900, 0, &threadId));
	CloseHandle(CreateThread(NULL, 0, ReadThread, (LPVOID)1100, 0, &threadId));
	CloseHandle(CreateThread(NULL, 0, ReadThread, (LPVOID)1400, 0, &threadId));

	Sleep(10000);
	SetEvent(g_hStop);
	Sleep(100);

	return 0;
}